--AH:ScriptId=fa968e80-68da-496e-8d49-1b3bdc63ad27;670
CREATE TABLE [Scripts]
(
	[Script_Id] INT IDENTITY(1,1) NOT NULL,
	[Script_Name] NVARCHAR(50) NOT NULL,
	[ScriptType_Code] VARCHAR(20) NOT NULL,
	[Description_Text] NVARCHAR(MAX),
	[Active_Indicator] YNINDICATOR NOT NULL,
	[AutoSync_Indicator] YNINDICATOR NOT NULL,
	[CreatedBy_User_Name] USERNAME NOT NULL,
	[CreatedOn_Date] DATETIME NOT NULL,
	[ModifiedBy_User_Name] USERNAME NOT NULL,
	[ModifiedOn_Date] DATETIME NOT NULL,

	CONSTRAINT [PK__Scripts]
		PRIMARY KEY ([Script_Id]),

	CONSTRAINT [UQ__Scripts__Script_Name]
		UNIQUE ([Script_Name]),

	CONSTRAINT [CK__Scripts__Script_Name]
		CHECK ([Script_Name] <> '')
)

CREATE TABLE [ScriptVersions]
(
	[Script_Id] INT NOT NULL,
	[Version_Number] INT NOT NULL,
	[Script_Bytes] VARBINARY(MAX) NOT NULL,
	[CreatedBy_User_Name] USERNAME NOT NULL,
	[CreatedOn_Date] DATETIME NOT NULL,

	CONSTRAINT [PK__ScriptVersions]
		PRIMARY KEY ([Script_Id], [Version_Number]),

	CONSTRAINT [CK__ScriptVersions__Version_Number]
		CHECK ([Version_Number] > 0)
)

CREATE TABLE [ScriptParameters]
(
	[Script_Id] INT NOT NULL,
	[Parameter_Name] NVARCHAR(50) NOT NULL,
	[ParameterType_Code] CHAR(1) NOT NULL,
	[Description_Text] NVARCHAR(MAX),
	[DefaultValue_Text] NVARCHAR(MAX),

	CONSTRAINT [PK__ScriptParameters]
		PRIMARY KEY ([Script_Id], [Parameter_Name]),

	CONSTRAINT [FK__ScriptParameters__Scripts]
		FOREIGN KEY ([Script_Id]) REFERENCES [Scripts] ([Script_Id]),

	CONSTRAINT [CK__ScriptParameters__Parameter_Name]
		CHECK ([Parameter_Name] <> ''),

	CONSTRAINT [CK__ScriptParameters__ParameterType_Code]
		CHECK ([ParameterType_Code] IN ('S', 'T', 'C'))
)
