--AH:ScriptId=5de089fc-c075-49e7-b6c9-7d24a052f0a2;1742
CREATE TABLE [DeploymentPlans]
(
	[DeploymentPlan_Id] INT IDENTITY(1,1) NOT NULL,
	[DeploymentPlan_Name] NVARCHAR(50) NULL,

	CONSTRAINT [PK__DeploymentPlans]
		PRIMARY KEY ([DeploymentPlan_Id]),

	CONSTRAINT [CK__DeploymentPlans__DeploymentPlan_Name]
		CHECK ([DeploymentPlan_Name] <> '')
)

CREATE TABLE [ApplicationDeploymentPlans]
(
	[Application_Id] INT NOT NULL,
	[Environment_Id] INT NOT NULL,
	[DeploymentPlan_Id] INT NOT NULL,

	CONSTRAINT [PK__ApplicationDeploymentPlans]
		PRIMARY KEY ([Application_Id], [Environment_Id]),

	CONSTRAINT [FK__ApplicationDeploymentPlans__Applications]
		FOREIGN KEY ([Application_Id])
		REFERENCES [Applications] ([Application_Id]),

	CONSTRAINT [FK__ApplicationDeploymentPlans__Environments]
		FOREIGN KEY ([Environment_Id])
		REFERENCES [Environments] ([Environment_Id]),

	CONSTRAINT [FK__ApplicationDeploymentPlans__DeploymentPlans]
		FOREIGN KEY ([DeploymentPlan_Id])
		REFERENCES [DeploymentPlans] ([DeploymentPlan_Id])
)

CREATE TABLE [DeploymentPlanActionGroups]
(
	[DeploymentPlanActionGroup_Id] INT IDENTITY(1,1) NOT NULL,
	[DeploymentPlan_Id] INT NOT NULL,
	[DeploymentPlanActionGroup_Sequence] INT NOT NULL,
	[ActionGroup_Id] INT NOT NULL,
	[Deployable_Name] VARCHAR(50) NULL,
	[Deployable_Application_Id] INT NULL,
	[Active_Indicator] YNINDICATOR NOT NULL,
	[ActionGroup_Name] NVARCHAR(50) NULL,
	[ActionGroup_Description] NVARCHAR(MAX) NULL,
	[Predicate_Configuration] XML NULL,
	[Server_Id] INT NULL,
	[Server_Variable_Name] VARCHAR(50) NULL,
	[Iterate_Servers_Indicator] YNINDICATOR NOT NULL,
	[Iterate_Deployables_Indicator] YNINDICATOR NOT NULL,
	[Parallel_Indicator] YNINDICATOR NOT NULL,
	[OnSuccess_DeploymentPlanActionGroup_Id] INT NULL,
	[OnFailure_DeploymentPlanActionGroup_Id] INT NULL,
	[OnFailure_Continue_Indicator] YNINDICATOR NULL,
	[ModifiedBy_User_Name] USERNAME NOT NULL,
	[ModifiedOn_Date] DATETIME NOT NULL,

	CONSTRAINT [PK__DeploymentPlanActionGroups]
		PRIMARY KEY ([DeploymentPlanActionGroup_Id]),

	CONSTRAINT [FK__DeploymentPlanActionGroups__DeploymentPlans]
		FOREIGN KEY ([DeploymentPlan_Id])
		REFERENCES [DeploymentPlans] ([DeploymentPlan_Id]),

	CONSTRAINT [FK__DeploymentPlanActionGroups__ActionGroups]
		FOREIGN KEY ([ActionGroup_Id])
		REFERENCES [ActionGroups] ([ActionGroup_Id]),

	CONSTRAINT [FK__DeploymentPlanActionGroups__Applications]
		FOREIGN KEY ([Deployable_Application_Id])
		REFERENCES [Applications] ([Application_Id]),

	CONSTRAINT [FK__DeploymentPlanActionGroups__Servers]
		FOREIGN KEY ([Server_Id])
		REFERENCES [Servers] ([Server_Id]),

	CONSTRAINT [FK__DeploymentPlanActionGroups__OnSuccess_DeploymentPlanActionGroups]
		FOREIGN KEY ([OnSuccess_DeploymentPlanActionGroup_Id])
		REFERENCES [DeploymentPlanActionGroups] ([DeploymentPlanActionGroup_Id]),

	CONSTRAINT [FK__DeploymentPlanActionGroups__OnFailure_DeploymentPlanActionGroups]
		FOREIGN KEY ([OnFailure_DeploymentPlanActionGroup_Id])
		REFERENCES [DeploymentPlanActionGroups] ([DeploymentPlanActionGroup_Id]),

	CONSTRAINT [CK__DeploymentPlanActionGroups__Deployable_Name]
		CHECK ([Deployable_Name] <> ''),

	CONSTRAINT [CK__DeploymentPlanActionGroups__Deployable_Application_Id]
		CHECK ([Deployable_Application_Id] IS NULL OR [Deployable_Name] IS NOT NULL),

	CONSTRAINT [CK__DeploymentPlanActionGroups__DeploymentPlanActionGroup_Sequence]
		CHECK ([DeploymentPlanActionGroup_Sequence] > 0),

	CONSTRAINT [CK__DeploymentPlanActionGroups__Server]
		CHECK ([Server_Variable_Name] <> '' AND ([Server_Id] IS NULL OR [Server_Variable_Name] IS NULL)),

	CONSTRAINT [UQ__DeploymentPlanActionGroups__DeploymentPlanActionGroup_Sequence]
		UNIQUE ([DeploymentPlan_Id], [DeploymentPlanActionGroup_Sequence]),

	CONSTRAINT [CK__DeploymentPlanActionGroups__Iterate_Deployables]
		CHECK ([Iterate_Deployables_Indicator] = 'N' OR [Deployable_Name] IS NULL),

	CONSTRAINT [CK__DeploymentPlanActionGroups__OnFailure_Continue_Indicator]
		CHECK (([OnFailure_Continue_Indicator] IS NOT NULL AND [OnFailure_DeploymentPlanActionGroup_Id] IS NULL)
		   OR ([OnFailure_Continue_Indicator] IS NULL AND [OnFailure_DeploymentPlanActionGroup_Id] IS NOT NULL))
)