--AH:ScriptId=bb154d7b-e7fb-4c71-8785-45ab13dd293f;1743
BEGIN TRAN

SELECT [Id] = ROW_NUMBER() OVER (ORDER BY [Application_Id], [Environment_Id]), 
       [Application_Id], [Environment_Id]
  INTO #DPAG
  FROM [PlanActionGroups]
 GROUP BY [Application_Id], [Environment_Id]

SET IDENTITY_INSERT [DeploymentPlans] ON
INSERT [DeploymentPlans] ([DeploymentPlan_Id]) SELECT [Id] FROM #DPAG
SET IDENTITY_INSERT [DeploymentPlans] OFF

INSERT INTO [ApplicationDeploymentPlans] ([DeploymentPlan_Id],[Application_Id], [Environment_Id])
SELECT [Id],[Application_Id], [Environment_Id] FROM #DPAG

SET IDENTITY_INSERT [DeploymentPlanActionGroups] ON
INSERT INTO [DeploymentPlanActionGroups]
      ([DeploymentPlanActionGroup_Id]
	  ,[DeploymentPlan_Id]
      ,[DeploymentPlanActionGroup_Sequence]
      ,[ActionGroup_Id]
      ,[Deployable_Name]
      ,[Deployable_Application_Id]
      ,[Active_Indicator]
      ,[ActionGroup_Name]
      ,[ActionGroup_Description]
      ,[Predicate_Configuration]
      ,[Server_Id]
      ,[Server_Variable_Name]
      ,[Iterate_Servers_Indicator]
      ,[Iterate_Deployables_Indicator]
      ,[Parallel_Indicator]
      ,[OnSuccess_DeploymentPlanActionGroup_Id]
      ,[OnFailure_DeploymentPlanActionGroup_Id]
      ,[OnFailure_Continue_Indicator]
      ,[ModifiedBy_User_Name]
      ,[ModifiedOn_Date])
SELECT [DeploymentPlanActionGroup_Id] = PAG.[PlanActionGroup_Id],
       [DeploymentPlan_Id] = ADP.[DeploymentPlan_Id],
       [DeploymentPlanActionGroup_Sequence] = PAG.[PlanActionGroup_Sequence],
       [ActionGroup_Id] = PAG.[ActionGroup_Id],
       [Deployable_Name] = NULLIF(D.[Deployable_Name], ''),
       [Deployable_Application_Id] = CASE WHEN D.[Application_Id] <> PAG.[Application_Id] THEN D.[Application_Id] ELSE NULL END,
       [Active_Indicator] = PAG.[Active_Indicator],
       [ActionGroup_Name] = PAG.[ActionGroup_Name],
       [ActionGroup_Description] = PAG.[ActionGroup_Description],
       [Predicate_Configuration] = PAG.[Predicate_Configuration],
       [Server_Id] = PAG.[Server_Id],
       [Server_Variable_Name] = PAG.[Server_Variable_Name],
	   'N','N','N',NULL,NULL,'N',
       [ModifiedBy_User_Name] = COALESCE(PAG.[ModifiedBy_User_Name], AG.[ModifiedBy_User_Name]),
       [ModifiedOn_Date] = COALESCE(PAG.[ModifiedOn_Date], AG.[ModifiedOn_Date])
  FROM [PlanActionGroups] PAG
       INNER JOIN [ApplicationDeploymentPlans] ADP
               ON ADP.[Application_Id] = PAG.[Application_Id]
              AND ADP.[Environment_Id] = PAG.[Environment_Id]
        LEFT JOIN [Deployables] D
               ON PAG.[Deployable_Id] = D.[Deployable_Id]
       INNER JOIN [ActionGroups] AG
               ON AG.[ActionGroup_Id] = PAG.[ActionGroup_Id]
 ORDER BY PAG.[Application_Id], PAG.[Environment_Id], PAG.[PlanActionGroup_Sequence]
 SET IDENTITY_INSERT [DeploymentPlanActionGroups] OFF
  
COMMIT

