--AH:ScriptId=2fbb11d7-7c21-4923-93e4-66c4381aa9b7;2757
/*
 drop table [EventListenerEnvironments]
 drop table [EventListenerApplications]
 drop table [EventListenerApplicationGroups]
 drop table [EventListenerEvents]
 drop table [EventListeners]
 */
 
 CREATE TABLE [EventListeners] (
	[EventListener_Id] INT IDENTITY(1,1) NOT NULL
		CONSTRAINT [PK__EventListeners]
		PRIMARY KEY ([EventListener_Id]),

	[EventListener_Description] NVARCHAR(MAX) NOT NULL,
	[EventListener_Configuration] XML NOT NULL,

	[Owner_User_Name] USERNAME NULL,
	[Active_Indicator] YNINDICATOR NOT NULL,

	[WorkflowStep_Workflow_Id] INT NULL,
	[WorkflowStep_Environment_Id] INT NULL,
	CONSTRAINT [FK__EventListeners__WorkflowSteps]
	FOREIGN KEY ([WorkflowStep_Workflow_Id],[WorkflowStep_Environment_Id])
	REFERENCES [WorkflowSteps]([Workflow_Id], [Environment_Id])
)

CREATE TABLE [EventListenerEnvironments] (
	[EventListener_Id] INT NOT NULL
		CONSTRAINT [FK__EventListenerEnvironments__EventListeners]
		FOREIGN KEY([EventListener_Id])
		REFERENCES [EventListeners]([EventListener_Id]),

	[Environment_Id] INT NOT NULL
		CONSTRAINT [FK__EventListenerEnvironments__Environments]
		FOREIGN KEY([Environment_Id])
		REFERENCES [Environments] ([Environment_Id]),
	
	CONSTRAINT [PK__EventListenerEnvironments] 
	PRIMARY KEY ([EventListener_Id],[Environment_Id])
)

CREATE TABLE [EventListenerApplicationGroups] (
	[EventListener_Id] INT NOT NULL
		CONSTRAINT [FK__EventListenerApplicationGroups__EventListeners]
		FOREIGN KEY([EventListener_Id])
		REFERENCES [EventListeners]([EventListener_Id]),

	[ApplicationGroup_Id] INT NOT NULL
		CONSTRAINT [FK__EventListenerApplicationGroups__ApplicationGroups]
		FOREIGN KEY([ApplicationGroup_Id])
		REFERENCES [ApplicationGroups] ([ApplicationGroup_Id]),
	
	CONSTRAINT [PK__EventListenerApplicationGroups] 
	PRIMARY KEY ([EventListener_Id],[ApplicationGroup_Id])
)

CREATE TABLE [EventListenerApplications] (
	[EventListener_Id] INT NOT NULL
		CONSTRAINT [FK__EventListenerApplications__EventListeners]
		FOREIGN KEY([EventListener_Id])
		REFERENCES [EventListeners]([EventListener_Id]),

	[Application_Id] INT NOT NULL
		CONSTRAINT [FK__EventListenerApplications__Applications]
		FOREIGN KEY([Application_Id])
		REFERENCES [Applications] ([Application_Id]),
	
	CONSTRAINT [PK__EventListenerApplications] 
	PRIMARY KEY ([EventListener_Id],[Application_Id])
)

CREATE TABLE [EventListenerEvents] (
	[EventListener_Id] INT NOT NULL
		CONSTRAINT [FK__EventListenerEvents__EventListeners]
		FOREIGN KEY([EventListener_Id])
		REFERENCES [EventListeners]([EventListener_Id]),
	[Event_Code] CHAR(6) NOT NULL
		CONSTRAINT [FK__EventListenerEvents__EventTypes]
		FOREIGN KEY([Event_Code])
		REFERENCES [EventTypes] ([Event_Code]),
	CONSTRAINT [PK__EventListenerEvents] 
	PRIMARY KEY ([EventListener_Id],[Event_Code])
)

