IF OBJECT_ID('[EventListenerExecutions_Extended]') IS NOT NULL DROP VIEW [EventListenerExecutions_Extended]
GO

CREATE VIEW [EventListenerExecutions_Extended] AS

	SELECT ELE.[Execution_Id]
		  ,A.[Application_Id]
		  ,ELE.[PlanText_Bytes]
		  ,[ExecutionStart_Date] = E.[Start_Date]
		  ,[ExecutionEnded_Date] = E.[End_Date]
		  ,E.[ExecutionRunState_Code]
		  ,E.[ExecutionStatus_Code]
		  ,[ExecutionStatus_Name] =
		   CASE
				WHEN E.[ExecutionRunState_Code] = 'P' THEN 'Pending'
				WHEN E.[ExecutionRunState_Code] = 'X' AND E.[CanceledOn_Date] IS NULL THEN 'Executing'
				WHEN E.[ExecutionRunState_Code] = 'X' AND E.[CanceledOn_Date] IS NOT NULL THEN 'Canceled'
				WHEN E.[ExecutionStatus_Code] = 'E' THEN 'Failed'
				ELSE 'Succeeded'
		   END
		  ,E.[CreatedBy_User_Name]
		  ,E.[CreatedOn_Date]
		  ,E.[CanceledBy_User_Name]
		  ,E.[CanceledOn_Date]
		  ,A.[Application_Name]
		  ,[WarningLogEntry_Indicator] = CASE WHEN E.[ExecutionStatus_Code] = 'W' THEN 'Y' ELSE 'N' END
		  ,A.[ApplicationGroup_Id]
		  ,ELE.[EventOccurrence_Id]
		  ,EO.[Event_Code]
		  ,EO.[Occurence_Date]

	  FROM [EventListenerExecutions] ELE
	       INNER JOIN [Executions] E
		          ON E.[Execution_Id] = ELE.[Execution_Id]
			LEFT JOIN [EventOccurences] EO
			      ON EO.[EventOccurence_Id] = ELE.[EventOccurrence_Id]
		    LEFT JOIN [Applications] A
				  ON A.[Application_Id] = EO.[Application_Id]

GO
