IF OBJECT_ID('[Releases_Slim]') IS NOT NULL DROP VIEW [Releases_Slim]
GO

CREATE VIEW [Releases_Slim] AS

SELECT R.[Application_Id]
      ,R.[Release_Number]
      ,R.[ReleaseStatus_Name]
      ,R.[Notes_Text]
      ,[Target_Date] = RT_LATEST_END.[End_Date]
      ,[Release_Name] = COALESCE(R.[Release_Name],R.[Release_Number])
      ,R.[CreatedBy_User_Name]
      ,R.[CreatedOn_Date]
      ,R.[ModifiedBy_User_Name]
      ,R.[ModifiedOn_Date]
      ,R.[CancelledBy_User_Name]
      ,R.[CancelledReason_Text]
      ,R.[CancelledOn_Date]
      ,R.[Release_Sequence]
      ,R.[Release_Id]
      ,R.[Furthest_Build_Number]
      ,R.[ReleaseTemplate_Name]

	  ,A.[Application_Name]

	  ,R.[Pipeline_Name]

  FROM [Releases] R
	   INNER JOIN [Applications] A
               ON R.[Application_Id] = A.[Application_Id]
       OUTER APPLY(
            SELECT TOP 1 * FROM [ReleaseTargetDates] RTD WHERE RTD.[Release_Id] = R.[Release_Id] ORDER BY RTD.[End_Date] DESC
       ) RT_LATEST_END

GO




