EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'ApiKeys_LogRequest',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ NULL,
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Logs a request made with an API key.'
GO

IF OBJECT_ID('[ApiKeys_LogRequest]') IS NOT NULL DROP PROCEDURE [ApiKeys_LogRequest]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [ApiKeys_LogRequest]
(
    @ApiKey_Text VARCHAR(50),
    @Request_Date DATETIME,
    @Request_Url VARCHAR(MAX),
    @Request_Method VARCHAR(5),
    @Request_Ip_Address VARCHAR(20),
    @Response_StatusCode INT,
    @Request_Body VARBINARY(MAX),
    @Response_Body VARBINARY(MAX)
)
AS
BEGIN

	SET NOCOUNT ON

    DECLARE @Min_ApiKeyAccessLog_Id INT
    SELECT @Min_ApiKeyAccessLog_Id = MIN([ApiKeyAccessLog_Id])
     FROM (SELECT TOP 1000 [ApiKeyAccessLog_Id] FROM [ApiKeyAccessLogs] ORDER BY [ApiKeyAccessLog_Id] DESC) [Logs]

    DELETE [ApiKeyAccessLogs]
     WHERE [ApiKeyAccessLog_Id] < @Min_ApiKeyAccessLog_Id

	INSERT INTO [ApiKeyAccessLogs]
    (
        [ApiKey_Text],
        [Request_Date],
        [Request_Url],
        [Request_Method],
        [Request_Ip_Address],
        [Request_Body],
        [Response_StatusCode],
        [Response_Body]
    )
    VALUES
    (
        @ApiKey_Text,
        @Request_Date,
        @Request_Url,
        @Request_Method,
        @Request_Ip_Address,
        @Request_Body,
        @Response_StatusCode,
        @Response_Body
    )

END
GO

GRANT EXECUTE ON [ApiKeys_LogRequest] TO [BuildMasterUser_Role]