EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'BuildTestResults_RecordTestResult',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Logs the result of an individual unit test.'
GO

IF OBJECT_ID('[BuildTestResults_RecordTestResult]') IS NOT NULL DROP PROCEDURE [BuildTestResults_RecordTestResult]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [BuildTestResults_RecordTestResult]
(
	@Execution_Id INT,
	@Group_Name NVARCHAR(50),
	@Test_Name NVARCHAR(255),
	@TestStatus_Code CHAR(1),
	@TestResult_Text NVARCHAR(MAX),
	@TestStarted_Date DATETIME,
	@TestDuration_Milliseconds BIGINT
)
AS
BEGIN

	SET NOCOUNT ON

	INSERT INTO [BuildTestResults]
			   ([Execution_Id]
			   ,[Test_Sequence]
			   ,[Group_Name]
			   ,[Test_Name]
			   ,[TestStatus_Code]
			   ,[TestResult_Text]
			   ,[TestStarted_Date]
			   ,[TestDuration_Milliseconds])
		 SELECT
				@Execution_Id,
				ISNULL(MAX([Test_Sequence]), 0) + 1,
				@Group_Name,
				@Test_Name,
				@TestStatus_Code,
				@TestResult_Text,
				@TestStarted_Date,
				@TestDuration_Milliseconds
		   FROM [BuildTestResults]
           WHERE [Execution_Id] = @Execution_Id

END
GO

GRANT EXECUTE ON [BuildTestResults_RecordTestResult] TO [BuildMasterUser_Role]
