EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Builds_GetExecutionsInProgress',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'PipelineStageTargetExecutions_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets all executions in the executing state optionally filtered by application.'
GO


IF OBJECT_ID('[Builds_GetExecutionsInProgress]') IS NOT NULL DROP PROCEDURE [Builds_GetExecutionsInProgress]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Builds_GetExecutionsInProgress]
(
	@Application_Id INT = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT *
	  FROM [PipelineStageTargetExecutions_Extended]
	 WHERE (@Application_Id IS NULL OR [Application_Id] = @Application_Id)
	   AND [ExecutionRunState_Code] = 'X'
	 ORDER BY [ExecutionStart_Date] DESC

END
GO

GRANT EXECUTE ON [Builds_GetExecutionsInProgress] TO [BuildMasterUser_Role]
