EXEC [__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'UserDirectories_DeleteDirectory',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ 'UserDirectory_Id',
    /* Description_Text        */ 'Creates a new user directory or updates an existing one.'
GO

IF OBJECT_ID('[UserDirectories_DeleteDirectory]') IS NOT NULL DROP PROCEDURE [UserDirectories_DeleteDirectory]
GO

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE PROCEDURE [UserDirectories_DeleteDirectory]
(
	@UserDirectory_Id INT
)
AS
BEGIN

SET NOCOUNT ON
SET QUOTED_IDENTIFIER ON

BEGIN TRY
	BEGIN TRANSACTION

    DELETE [Privileges]
     WHERE [UserDirectory_Id] = @UserDirectory_Id

	DELETE [UserDirectories]
     WHERE [UserDirectory_Id] = @UserDirectory_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH


END
GO

GRANT EXECUTE ON [UserDirectories_DeleteDirectory] TO [BuildMasterUser_Role]